"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const Boolean_1 = __importDefault(require("./Boolean"));
const Number_1 = __importDefault(require("./Number"));
const String_1 = __importDefault(require("./String"));
const Color_1 = __importDefault(require("./Color"));
const Date_1 = __importDefault(require("./Date"));
const DateTime_1 = __importDefault(require("./DateTime"));
const Email_1 = __importDefault(require("./Email"));
const File_1 = __importDefault(require("./File"));
const Telephone_1 = __importDefault(require("./Telephone"));
const Time_1 = __importDefault(require("./Time"));
const Url_1 = __importDefault(require("./Url"));
const Empty_1 = __importDefault(require("./Empty"));
const List_1 = __importDefault(require("./List"));
const Object_1 = __importDefault(require("./Object"));
const Optional_1 = __importDefault(require("./Optional"));
exports.default = {
    //Basic Helper Functions
    boolean: (defaultValue) => new Boolean_1.default(defaultValue),
    number: (defaultValue) => new Number_1.default(defaultValue),
    string: (defaultValue) => new String_1.default(defaultValue),
    Color: (defaultValue) => new Color_1.default(defaultValue),
    Date: (defaultValue) => new Date_1.default(defaultValue),
    DateTime: (defaultValue) => new DateTime_1.default(defaultValue),
    Email: (defaultValue) => new Email_1.default(defaultValue),
    Telephone: (defaultValue) => new Telephone_1.default(defaultValue),
    Time: (defaultValue) => new Time_1.default(defaultValue),
    Url: (defaultValue) => new Url_1.default(defaultValue),
    Empty: () => new Empty_1.default(),
    File: () => new File_1.default(),
    // Complex Helper Functions
    List: function (type, seperator, defaultValue) {
        return new List_1.default(type, seperator, defaultValue);
    },
    Object: function (properties, defaultValue) {
        return new Object_1.default(properties, defaultValue);
    },
    Optional: function (type, defaultValue) {
        return new Optional_1.default(type, defaultValue);
    }
};
/** Basic Types Map
 *
 * Can hopefully use this to create a function that takes easier to read objects.
 */
/*const Basic_Type_Map = {
    "boolean": BooleanValidator,
    "number": NumberValidator,
    "string": StringValidator,
    "Color": ColorValidator,
    "Date": DateValidator,
    "DateTime": DateTimeValidator,
    "Email": EmailValidator,
    "File": FileValidator,
    "Telephone": TelephoneValidator,
    "Time": TimeValidator,
    "Url": UrlValidator
}
type BasicTypes = typeof Basic_Type_Map;

//Basic Names Helper Array
export const BASIC_NAMES = [
    BooleanName, NumberName, StringName,
    ColorName, DateTimeName, DateName, EmailName, FileName,  TelephoneName, TimeName, UrlName
] as const;

//Name Types
export type BasicNames = typeof BASIC_NAMES[number]
export type TypeNames  = BasicNames | Dictionary<BasicNames> | Array<BasicNames>;
*/ 
